package ru.indvdum.mywork.openjpa.model;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.ManyToOne;
import javax.persistence.MapsId;
import javax.persistence.Table;

/**
 * @author indvdum
 * 16.08.2011 13:55:51
 *
 */
@Entity
@IdClass(WorkId.class)
@Table(name = "WORK")
public class Work implements IDatabaseObject {

	private static final long serialVersionUID = 7138260708537798813L;
	
//	@Id
//	@PrimaryKeyJoinColumn
//	@Column(name = "DAYID", nullable = false)
//	private Integer dayId = null;
//	
//	@Id
//	@PrimaryKeyJoinColumn
//	@Column(name = "TASKID", nullable = false)
//	private Integer taskId = null;
	
	@Column(name = "HOURS")
	private Float hours = null;
	
	@Column(name = "RESULT")
	private String result = null;
	
	@Id
	@ManyToOne(fetch = FetchType.EAGER, cascade = {CascadeType.PERSIST})
	Day day = null;
	
	@Id
	@ManyToOne(fetch = FetchType.EAGER, cascade = {CascadeType.PERSIST})
	Task task = null;
	
	public Work(){
		
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Work))
			return false;
		final Work other = (Work) obj;
		return (
				this.day == other.day 
				&& this.task == other.task 
				|| (
						this.day != null 
						&& this.day.equals(other.day) 
						&& this.task != null 
						&& this.task.equals(other.task)
						)
				);
	}

//	public Integer getDayId() {
//		return dayId;
//	}
//
//	public void setDayId(Integer dayId) {
//		this.dayId = dayId;
//	}
//
//	public Integer getTaskId() {
//		return taskId;
//	}
//
//	public void setTaskId(Integer taskId) {
//		this.taskId = taskId;
//	}

	public Float getHours() {
		return hours;
	}

	public void setHours(Float hours) {
		this.hours = hours;
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public Day getDay() {
		return day;
	}

	public void setDay(Day day) {
		this.day = day;
	}

}
