package ru.indvdum.mywork.vaadin;

import static ru.indvdum.mywork.MyWork.EM;

import java.util.List;

import javax.persistence.Query;

import ru.indvdum.mywork.openjpa.model.Day;
import ru.indvdum.mywork.openjpa.model.Task;
import ru.indvdum.mywork.openjpa.model.Work;

import com.vaadin.Application;
import com.vaadin.addon.jpacontainer.JPAContainer;
import com.vaadin.addon.jpacontainer.provider.LocalEntityProvider;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.TabSheet;
import com.vaadin.ui.Table;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Window;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;

/**
 * @author indvdum
 * 12.08.2011 17:31:53
 *
 */
public class MyWorkApplication extends Application {

	@Override
	public void init() {
		Window window = new Window();
		setMainWindow(window);
		
		Query query = EM.createQuery("select x from " + Work.class.getName() + " x");
		List list = query.getResultList();
		list.size();
		
		TabSheet tabSheet = new TabSheet();
		tabSheet.setSizeFull();
		window.setContent(tabSheet);
		
		VerticalLayout vlMain = new VerticalLayout();
		vlMain.setMargin(true);
		vlMain.setSpacing(true);
		tabSheet.addTab(vlMain, "Main page", null);
		
		LocalEntityProvider dayProvider = new LocalEntityProvider(Day.class);
		dayProvider.setEntityManager(EM);
		JPAContainer<Day> dayContainer = new JPAContainer(Day.class);
		dayContainer.setEntityProvider(dayProvider);
		
		final Table dayTable = new Table();
		dayTable.setSelectable(true);
		dayTable.setEditable(false);
		dayTable.setImmediate(true);
		dayTable.setSizeFull();
		dayTable.setContainerDataSource(dayContainer);
		vlMain.addComponent(dayTable);
		vlMain.setExpandRatio(dayTable, 1f);
		
		LocalEntityProvider taskProvider = new LocalEntityProvider(Task.class);
		taskProvider.setEntityManager(EM);
		JPAContainer<Task> taskContainer = new JPAContainer(Task.class);
		taskContainer.setEntityProvider(taskProvider);
		
		Table taskTable = new Table();
		taskTable.setSelectable(true);
		taskTable.setEditable(false);
		taskTable.setImmediate(true);
		taskTable.setSizeFull();
		taskTable.setContainerDataSource(taskContainer);
		vlMain.addComponent(taskTable);
		vlMain.setExpandRatio(taskTable, 1f);
	}
}
